/*
 * Macros to allow direct access to the I/O bits of the AVR
 * internal registers from DDS MICRO-C/AVR.
 *
 * This file **REQUIRES** the extended pre-processor (MCP).
 * (CCAVR ... -P, or "Preprocess" step enabled in DDSIDE)
 *
 * The 'setbit' and 'clrbit' macros use arguemnts in the standard
 * AVR assenbly language syntax of: address,bit
 *
 * Also, these macros expect the MEMORY address of the port, which
 * is automatically reduced by $20 to access the I/O address.
 *
 * Copyright 2000-2005 Dave Dunfield
 * All rights reserved.
 */

#define setbit(address, bit) asm {	/* Macro to set a I/O bit */\
 SBI address-$20,bit\
}

#define clrbit(address, bit) asm {	/* Macro to clear an I/O bit */\
 CBI address-$20,bit\
}
