;
; Special function register definitions for: AVR
;
; These are the internal Special Function Registers (SFR's) of the
; Atmel 90S8515... You may need to modify this file for use with other
; AVR devices. See also AVRREG.H
;
; NOTE: These equates reference the **MEMORY** address for the SFR's,
; so that they can be accessed from 'C' as memory locations. To use I/O
; addressing (IN/OUT/SBI/CBI/SBIS/SBIC), you must subtract $20 from the
; address.
;
ACSR	EQU	$28	; Analog Comparator Control and Status Register
UBRR	EQU	$29	; UART Baud Rate Register
UCR	EQU	$2A	; UART Control Register
USR	EQU	$2B	; UART Status Register
UDR	EQU	$2C	; UART I/O Data Register
SPCR	EQU	$2D	; SPI Control Register
SPSR	EQU	$2E	; SPI Status Register
SPDR	EQU	$2F	; SPI I/O Data Register
PIND	EQU	$30	; Input Pins, Port D
DDRD	EQU	$31	; Data Direction Register, Port D
PORTD	EQU	$32	; Data Register, Port D
PINC	EQU	$33	; Input Pins, Port C
DDRC	EQU	$34	; Data Direction Register, Port C
PORTC	EQU	$35	; Data Register, Port C
PINB	EQU	$36	; Input Pins, Port B
DDRB	EQU	$37	; Data Direction Register, Port B
PORTB	EQU	$38	; Data Register, Port B
PINA	EQU	$39	; Input Pins, Port A
DDRA	EQU	$3A	; Data Direction Register, Port A
PORTA	EQU	$3B	; Data Register, Port A
EECR	EQU	$3C	; EEPROM Control Register
EEDR	EQU	$3D	; EEPROM Data Register
EEAR	EQU	$3E	; EEPROM Address Register (word)
WDTCR	EQU	$41	; Watchdog Timer Control Register
ICR1	EQU	$44	; T/C 1 Input Capture Register (word)
OCR1B	EQU	$48	; Timer/Counter1 Output Compare Register B (word)
OCR1A	EQU	$4A	; Timer/Counter1 Output Compare Register A (word)
TCNT1	EQU	$4C	; Timer/Counter1
TCCR1B	EQU	$4E	; Timer/Counter 1 Control Register B
TCCR1A	EQU	$4F	; Timer/Counter 1 Control Register A
OCR0	EQU	$51	; Output Compare Register 0
TCNT0	EQU	$52	; Timer/Counter 0
TCCR0	EQU	$53	; Timer/Counter 0 Control Register
MCUCR	EQU	$55	; MCU general Control Register
TIFR	EQU	$58	; Timer/Counter Interrupt FLAG register
TIMSK	EQU	$59	; Timer/Counter Interrupt MASK register
GIMSK	EQU	$5B	; General Interrupt MASK register
SP	EQU	$5D	; Stack Pointer (word)
SREG	EQU	$5F	; Status REGister
