; Test for ASCII character
isascii	LDI	R20,$00		; Lowest valid
	LDI	R21,$7F+1	; Highest valid
	RJMP	?1		; Perform test
; Test for GRAPHIC character
isgraph	LDI	R20,$21		; Lowest valid
	LDI	R21,$7E+1	; Highest valid
	RJMP	?1		; Perform test
; Test for control character
iscntrl	LDD	R24,Y+0		; Get low value
	CPI	R24,$7F		; Special case
	BREQ	?3		; Allow it
	LDI	R20,$00		; Lowest valid
	LDI	R21,$1F+1	; Highest valid
	RJMP	?1		; Perform test
; Test for punctuation character
ispunct	RCALL	isalnum		; Alphanumeric
	BRNE	?2		; False, fail
; Test for printable character
isprint	LDI	R20,$20		; Lowest valid
	LDI	R21,$7E+1	; Highest valid
	RJMP	?1		; Perform test
; Test for alphanumeric
isalnum	RCALL	isdigit		; Numeric digit?
	BRNE	?4		; Yes, OK
; Test for alphapetic
isalpha	RCALL	isupper		; Uppercase
	BRNE	?4		; Yes, OK
; Test for LOWER CASE character
islower	LDI	R20,'a'		; Lowest valid
	LDI	R21,'z'+1	; Highest valid
	RJMP	?1		; Perform test
; Test for UPPERCASE character
isupper	LDI	R20,'A'		; Lowest valid
	LDI	R21,'Z'+1	; Highest valid
	RJMP	?1		; Perform test
; Test for HEX digit
isxdigit LDI	R20,'a'		; Lowest valid
	LDI	R21,'f'+1	; Highest valid
	RCALL	?1		; In range?
	BRNE	?4		; Ok
	LDI	R20,'A'		; Lowest valid
	LDI	R21,'F'+1	; Highest valid
	RCALL	?1		; In range?
	BRNE	?4		; OK
; Test for numeric digit
isdigit	LDI	R20,'0'		; Lowest valid
	LDI	R21,'9'+1	; Highest valid
?1	LDD	R24,Y+0		; Get character to test (low)
	CP	R24,R20		; In range?
	BRLO	?2		; No, fail
	CP	R24,R21		; In range?
	BRLO	?3		; Yes, pass
?2	CLR	R24		; Zero low
	CLR	R25		; Zero high
	RET
; Test for SPACE character
isspace	LDD	R24,Y+0		; Get character
	CPI	R24,' '		; Space?
	BREQ	?3		; Looks OK
	CPI	R24,9		; Tab?
	BREQ	?3		; Looks OK
	CPI	R24,$0A		; Newline
	BRNE	?2		; No, report error
?3	LDD	R25,Y+1		; Get high byte
	TST	R25		; High must be zero
	BRNE	?2		; No, fail
	LDI	R24,1		; Return 1
	TST	R24		; Clear Z
?4	RET
