;
; Write character to serial port: putch(char c)
;
putch	LD	R24,Y		; Get character to write
; **NOTE** ?putch is used by "printf", and MUST NOT modify any of
;          the registers which are used by "_format_" (See FORMAT.ASM)
?putch	SBIS	USR-$20,5	; Transmit empty?
	RJMP	?putch		; No, wait
	CLR	R25		; Zero high
	OUT	UDR-$20,R24	; Write to uart
	CPI	R24,$0A		; Newline?
	BRNE	?getch2		; No, exit
	LDI	R24,$0D		; Return
	RJMP	?putch		; And go again
;
; Check for character from the serial port
;
chkch	CLR	R25		; Zero high
	CLR	R24		; Zero low
	SBIC	USR-$20,7	; Receive ready
	RJMP	?getch1		; Yes, handle it
	RET
;
; Read a character from the serial port
;
getch	CLR	R25		; Zero high
	SBIS	USR-$20,7	; Receive ready?
	RJMP	getch		; No, wait
?getch1	IN	R24,UDR-$20	; Read data
	CPI	R24,$0D		; Return?
	BRNE	?getch2		; No, it's OK
	LDI	R24,$0A		; Convert to newline
?getch2	RET
