;
; Functions to perform LONG arithmetic
;
?LSIZE	EQU	4		; 4 bytes (32 bits)
$DD:Longreg	4
; Add two LONG numbers: longadd(n1, n2)
longadd	LDD	R30,Y+2		; Get n1
	LDD	R31,Y+3		; ""
	LDD	R26,Y+0		; Get n2
	LDD	R27,Y+1		; ""
?bigadd	LDI	R24,?LSIZE	; Get byte count
	CLC			; Zero carry in
?1	LD	R22,Z		; Get from n1
	LD	R23,X+		; Get from n2
	ADC	R22,R23		; Add together
	ST	Z+,R22		; Write back
	DEC	R24		; Finished?
	BRNE	?1		; Do them all
?2	CLR	R25		; Zero high
	ROL	R24		; Get carry out
	RET
; Subtract two LONG numbers: longsub(n1, n2)
longsub	LDD	R30,Y+2		; Get n1
	LDD	R31,Y+3		; ""
	LDD	R26,Y+0		; Get n2
	LDD	R27,Y+1		; ""
?bigsub	LDI	R24,?LSIZE	; Get byte count
	CLC			; Zero carry in
?3	LD	R22,Z		; Get from n1
	LD	R23,X+		; Get from n2
	SBC	R22,R23		; Perform subtract
	ST	Z+,R22		; Write back
	DEC	R24		; Reduce count
	BRNE	?3		; Do them all
	RJMP	?2		; Finish up
; Shift long number right: longshr(n)
longshr	LDD	R30,Y+0		; Get n
	LDD	R31,Y+1		; ""
?bigshr	LDI	R24,?LSIZE	; Get byte count
	ADIW	Z,?LSIZE	; Skip to end
	CLC			; Zero carry in
?4	LD	R22,-Z		; Get original value
	ROR	R22		; Shift over
	ST	Z,R22		; Resave
	DEC	R24		; Reduce count
	BRNE	?4		; Do them all
	RJMP	?2		; Finish up
; Shift long number left: longshl(n)
longshl	LDD	R30,Y+0		; Get n
	LDD	R31,Y+1		; ""
?bigshl	CLC			; Zero carry in
?bigslc	LDI	R24,?LSIZE	; Get byte count
?5	LD	R22,Z		; Get byte from source
	ROL	R22		; Shift over
	ST	Z+,R22		; Resave
	DEC	R24		; Reduce count
	BRNE	?5		; Do them all
	RJMP	?2		; Finish up
; Divide long number: longdiv(n1, n2)
;; memset(longreg, 0, sizeof(longreg));
longdiv	RCALL	?11		; Zero working reg
;; t = (BIG_WIDTH*8)+1;
	LDI	R21,(?LSIZE*8)+1 ;Get bit count
;; carry_zero: cy=0;
?6	CLC			; No carry in
;; for(;;) { cy = big_shift_left(n1, cy);
?7	LDD	R30,Y+2		; Address n1
	LDD	R31,Y+3		; ""
	RCALL	?bigslc		; Shift it
;;   if(!--t) return;
	DEC	R21		; Reduce count
	BREQ	?15		; End, exit
;;   big_shift_left(longreg, cy);
	LDI	R30,Longreg	; Point to temp
	LDI	R31,=Longreg	; Point to temp
	ROR	R24		; Set carry in
	RCALL	?bigslc		; Do shift
;;   if(big_compare(longreg, n2)) goto carry_zero;
	LDI	R30,Longreg	; Point to temp
	LDI	R31,=Longreg	; Point to temp
	LDD	R26,Y+0		; Address n2
	LDD	R27,Y+1		; ""
	RCALL	?bigcmp		; Do compare
	BRLO	?6		; Less, carry 0
;;   big_sub(longreg, n2);
	LDI	R30,Longreg	; Point to temp
	LDI	R31,=Longreg	; Point to temp
	LDD	R26,Y+0		; Address n2
	LDD	R27,Y+1		; ""
	RCALL	?bigsub		; Do subtract
;;   cy = 1; }
	SEC			; Set carry
	RJMP	?7		; And proceed
; Multiply two LONG numbers: longnum(n1, n2)
longmul	SBIW	Y,?LSIZE	; Create temp
;; memcpy(n3, n2, sizeof(n3));
	MOV	R30,R28		; Address temp
	MOV	R31,R29		; ""
	LDD	R26,Y+?LSIZE+0	; Get num2 pointer
	LDD	R27,Y+?LSIZE+1	; ""
	RCALL	?bigcpy		; Copy to temp
;; memset(Longreg, 0, sizeof(big_temp));
	RCALL	?11		; Zero working reg
;; do; { if(big_shift_right(n1, 0))
?8	LDD	R30,Y+?LSIZE+2	; Get n1 pointer
	LDD	R31,Y+?LSIZE+3	; ""
	RCALL	?bigshr		; Shift it
	BREQ	?9		; No, leave it
;;         big_add(Longreg, n3);
	LDI	R30,Longreg	; Point to working
	LDI	R31,=Longreg	; ""
	MOV	R26,R28		; Get temp pointer
	MOV	R27,R29		; ""
	RCALL	?bigadd
;;   if(!big_test(n1)) break;
?9	LDD	R30,Y+?LSIZE+2	; Get n1 pointer
	LDD	R31,Y+?LSIZE+3	; ""
	RCALL	?bigtst		; Test it
	BREQ	?10		; Exit
;;   big_shift_left(n3, 0);
	MOV	R30,R28		; Address temp
	MOV	R31,R29		; ""
	RCALL	?bigshl		; Do shift
;; } while(big_test(n3));
	MOV	R30,R28		; Address temp
	MOV	R31,R29		; ""
	RCALL	?bigtst		; Do test
	BRNE	?8		; Continue till finished
;; memcpy(n1, Longreg, sizeof(n1));
?10	ADIW	Y,?LSIZE	; Remove temp
	LDD	R30,Y+2		; Get num1 pointer
	LDD	R31,Y+3		; ""
	LDI	R26,Longreg	; Address working
	LDI	R27,=Longreg
	RJMP	?bigcpy		; Copy & return
; Zero the working register
?11	LDI	R30,Longreg	; Address working
	LDI	R31,=Longreg	; ""
?12	LDI	R25,?LSIZE	; Get byte count
	CLR	R24		; Zero value
?14	ST	Z+,R24		; Write value
	DEC	R25		; Reduce count
	BRNE	?14		; Do them all
?15	RET
; Test a LONG number for zero: longtst(n1)
longtst	LDD	R30,Y+0		; Get n1
	LDD	R31,Y+1		; ""
?bigtst	LDI	R25,?LSIZE	; Get byte count
?16	LD	R24,Z+		; Get data
	TST	R24		; Zero?
	BRNE	?17		; No, exit
	DEC	R25		; Reduce count
	BRNE	?16		; Do them all
?17	RET
; Compare two LONG numbers: longcmp(n1, n2)
longcmp	LDD	R30,Y+2		; Get n1
	LDD	R31,Y+3		; ""
	LDD	R26,Y+0		; Get n2
	LDD	R27,Y+1		; ""
?bigcmp	LDI	R25,?LSIZE	; Get byte count
	ADIW	Z,?LSIZE	; Adjust n1 pointer
	ADIW	X,?LSIZE	; Adjust n2 pointer
?18	LD	R24,-Z		; Get from n1
	LD	R23,-X		; Get from n2
	SUB	R24,R23		; Perform sub
	BRLO	?19		; It's lower
	BRNE	?20		; It's higher
	DEC	R25		; Reduce count
	BRNE	?18		; Do them all
	RET
?19	SER	R24		; Return -1
	SER	R25		; ""
	RET
?20	LDI	R25,0		; Zero high
	LDI	R24,1		; Return 1
	RET
; Copy one long to another: longcpy(n1, n2)
longcpy	LDD	R30,Y+2		; Get n1
	LDD	R31,Y+3		; ""
	LDD	R26,Y+0		; Get n2
	LDD	R27,Y+1		; ""
?bigcpy	LDI	R25,?LSIZE	; Get size
?21	LD	R24,X+		; Get from n2
	ST	Z+,R24		; Write to n1
	DEC	R25		; Reduce count
	BRNE	?21		; Do them all
	RET
; Set a long number: longset(n1, v)
longset	LDD	R30,Y+2		; Get n1
	LDD	R31,Y+3		; ""
	RCALL	?12		; Zero it
	LDD	R30,Y+2		; Get n1
	LDD	R31,Y+3		; ""
	LDD	R24,Y+0		; Get v
	LDD	R25,Y+1		; ""
	STD	Z+0,R24		; Write low
	STD	Z+1,R25		; Write high
	RET
