; Allocate a block of memory: char *malloc(size)
malloc	LDI	R30,?heap	; Point to heap
	LDI	R31,=?heap	; ""
	LDD	R18,Y+0		; Get requested size
	LDD	R19,Y+1		; ""
?1	LD	R24,Z		; Get flag
	TST	R24		; End of list?
	BREQ	?4		; Yes, allocate here
	LDD	R20,Z+1		; Get block size
	LDD	R21,Z+2		; ""
	DEC	R24		; Allocated?
	BRNE	?2		; No, skip to next
	CP	R20,R18		; Large enough?
	CPC	R21,R19		; ""
	BRSH	?3		; Yes, take this one
?2	ADD	R30,R20		; Skip to next
	ADC	R31,R21		; ""
	ADIW	Z,3		; Skip overhead
	RJMP	?1		; And proceed
?3	MOV	R24,R20		; Get old size
	MOV	R25,R21		; ""
	SUB	R24,R18		; Remove new size
	SBC	R25,R19		; ""
	SBIW	W,3		; Remove overhead
	BRLO	?6		; No-realloc
	BREQ	?6		; ""
	MOV	R26,R30		; Get block pointer
	MOV	R27,R31		; ""
	ADD	R26,R18		; Offset to new free block
	ADC	R27,R19		; ""
	LDI	R16,1		; Get de-allocated marker
	ST	X+,R16		; Write marker
	ST	Z+,R24		; Write size (low)
	ST	Z,R25		; Write size (high)
	RJMP	?5		; And proceed
?4	MOV	R26,R30		; Get pointer to block
	MOV	R27,R31		; ""
	ADD	R26,R18		; Affset for size
	ADC	R27,R19		; ""
	ADIW	X,3		; Skip overhead
	CLR	R16		; End of list
	ST	X,R16		; Zero terminate
?5	STD	Z+1,R18		; Set size
	STD	Z+2,R19		; ""
?6	LDI	R16,2		; Allocated
	STD	Z+0,R16		; Set marker
	ADIW	Z,3		; Skip to data
?7	MOV	R24,R30		; Get pointer for return
	MOV	R25,R31		; ""
	RET
; Release a block of memory
free	LDD	R26,Y+0		; Get block pointer
	LDD	R27,Y+1		; ""
	SBIW	X,3		; Back to "real" beginning
	LDI	R30,?heap	; Point to heap
	LDI	R31,=?heap	; ""
?10	LD	R24,Z		; Get status
	TST	R24		; End of list?
	BREQ	?12		; We are finished
	CP	R30,R26		; Is this it?
	CPC	R31,R27		; ""
	BREQ	?11		; Yes, handle it
	LDD	R24,Z+1		; Get size
	LDD	R25,Z+2		; ""
	ADD	R30,R24		; Add to address
	ADC	R31,R25		; ""
	ADIW	Z,3		; Skip overhead
	RJMP	?10		; And proceed
?11	LDI	R24,1		; Get free block
	ST	Z,R24		; Release it
; Garbage collection
?12	LDI	R30,?heap	; Point to heap
	LDI	R31,=?heap	; ""
?20	LD	R16,Z		; Get allocation flag
	TST	R16		; End of heap?
	BREQ	?25		; Yes, exit
	LDD	R24,Z+1		; Get size
	LDD	R25,Z+2		; ""
	DEC	R16		; De-allocated?
	BRNE	?23		; No, try next
?21	MOV	R26,R30		; Get starting position
	MOV	R27,R31		; ""
	ADD	R26,R24		; Add offset
	ADC	R27,R25		; ""
	ADIW	X,3		; Skip overhead
	LD	R16,X+		; Get data
	TST	R16		; End of list
	BREQ	?24		; Yes, truncate
	DEC	R16		; De-allocated?
	BRNE	?22		; Stop looking
; This block also free
	LD	R18,X+		; Get size
	LD	R19,X+		; ""
	ADD	R24,R18		; Add to total
	ADC	R25,R19		; ""
	ADIW	W,3		; Include overhead
	RJMP	?21		; And proceed
?22	STD	Z+1,R24		; Save new size
	STD	Z+2,R25		; ""
?23	ADD	R30,R24		; Advance to next block
	ADC	R31,R25		; ""
	ADIW	Z,3		; Skip overhead
	RJMP	?20		; And get next
?24	CLR	R16		; Zero
	ST	Z,R16		; Truncate list
?25	RET
